import java.awt.*;
import java.awt.event.*;

public class Pool extends Animator {

	private int numBalls = 11;
	private Ball[] ball = new Ball[numBalls];
	private Ball cueBall = new Ball(400,100,15,0,0,Color.white);
	private Cue cue = new Cue(50,1,cueBall);

	public void startup()
	{
		ball[0] = cueBall;
		double r = ball[0].getRadius(); 
		double pi = Math.PI;
		R2Vector u1 = R2Vector.dirVec(5*pi/6);	// Direction vectors for locating other balls.
		R2Vector u2 = R2Vector.dirVec(3*pi/2);
		ball[1] = new Ball(150,getSceneHeight()/2,r,0,0,Color.red);
		ball[2] = new Ball(ball[1].getCenter().plus(u1.times(2.001*r)),r,new R2Vector(),Color.green);
		ball[3] = new Ball(ball[2].getCenter().plus(u2.times(2.001*r)),r,new R2Vector(),Color.black);
		ball[4] = new Ball(ball[2].getCenter().plus(u1.times(2.001*r)),r,new R2Vector(),Color.yellow);
		ball[5] = new Ball(ball[4].getCenter().plus(u2.times(2.001*r)),r,new R2Vector(),Color.orange);
		ball[6] = new Ball(ball[5].getCenter().plus(u2.times(2.001*r)),r,new R2Vector(),Color.magenta);
		ball[7] = new Ball(ball[4].getCenter().plus(u1.times(2.001*r)),r,new R2Vector(),Color.gray);
		ball[8] = new Ball(ball[7].getCenter().plus(u2.times(2.001*r)),r,new R2Vector(),Color.pink);
		ball[9] = new Ball(ball[8].getCenter().plus(u2.times(2.001*r)),r,new R2Vector(),Color.lightGray);
		ball[10] = new Ball(ball[9].getCenter().plus(u2.times(2.001*r)),r,new R2Vector(),Color.blue);

		addMouseMotionListenerToScene(cue);
		addMouseListenerToScene(cue);
	}

	private boolean allBallsStopped(){
		for (int i=0; i<numBalls; i++)
			if (ball[i].getVelocity().length() > 0) return false;
		return true;
	}

    public void draw(Graphics g) {
		for (int i=0; i<numBalls; i++){ ball[i].move(); }
		cue.move();
		Collision.checkCollisions(ball);
		for (int i=0; i<numBalls; i++)	ball[i].draw(g);
		if (allBallsStopped()) cue.draw(g);
	}// end of draw method

}//end of Pool class
